#define EigenArray Eigen::ArrayXd
#define EigenVector Eigen::VectorXd
#define EigenDiagonal Eigen::DiagonalMatrix<double,-1,-1>
#define EigenMatrix Eigen::MatrixXd
#define EigenZero Eigen::MatrixXd::Zero
#define EigenOne Eigen::MatrixXd::Identity

#define __Name_2_Z__\
    std::map<std::string, double> Name2Z = {\
	        {"H" ,  1}, {"HE",  2}, {"LI",  3}, {"BE",  4}, {"B" ,  5},\
	        {"C" ,  6}, {"N" ,  7}, {"O" ,  8}, {"F" ,  9}, {"NE", 10},\
	        {"NA", 11}, {"MG", 12}, {"AL", 13}, {"SI", 14}, {"P" , 15},\
	        {"S" , 16}, {"CL", 17}, {"AR", 18}, {"K" , 19}, {"CA", 20},\
	        {"SC", 21}, {"TI", 22}, {"V" , 23}, {"CR", 24}, {"MN", 25},\
	        {"FE", 26}, {"CO", 27}, {"NI", 28}, {"CU", 29}, {"ZN", 30},\
			{"GA", 31}, {"GE", 32}, {"AS", 33}, {"SE", 34}, {"BR", 35},\
			{"KR", 36}, {"RB", 37}, {"SR", 38}, {"Y" , 39}, {"ZR", 40},\
			{"NB", 41}, {"MO", 42}, {"TC", 43}, {"RU", 44}, {"RH", 45},\
			{"PD", 46}, {"AG", 47}, {"CD", 48}, {"IN", 49}, {"SN", 50},\
			{"SB", 51}, {"TE", 52}, {"I" , 53}, {"XE", 54}, {"CS", 55},\
			{"BA", 56}, {"LA", 57}, {"CE", 58}, {"PR", 59}, {"ND", 60},\
			{"PM", 61}, {"SM", 62}, {"EU", 63}, {"GD", 64}, {"TB", 65},\
			{"DY", 66}, {"HO", 67}, {"ER", 68}, {"TM", 69}, {"YB", 70},\
			{"LU", 71}, {"HF", 72}, {"TA", 73}, {"W" , 74}, {"RE", 75},\
			{"OS", 76}, {"IR", 77}, {"PT", 78}, {"AU", 79}, {"HG", 80},\
			{"TL", 81}, {"PB", 82}, {"BI", 83}, {"PO", 84}, {"AT", 85},\
			{"RN", 86}, {"FR", 87}, {"RA", 88}, {"AC", 89}, {"TH", 90},\
			{"PA", 91}, {"U" , 92}, {"NP", 93}, {"PU", 94}, {"AM", 95},\
			{"CM", 96}, {"BK", 97}, {"CF", 98}, {"ES", 99}, {"FM",100},\
			{"MD",101}, {"NO",102}, {"LR",103}, {"RF",104}, {"DB",105},\
			{"SG",106}, {"BH",107}, {"HS",108}, {"MT",109}, {"DS",110}\
    };

#define __Z_2_Name__\
    std::string Z2Name[] = {"FuckIndexZero",\
	        "H" , "He", "Li", "Be", "B" , "C" , "N" , "O" , "F" , "Ne",\
	        "Na", "Mg", "Al", "Si", "P" , "S" , "Cl", "Ar", "K" , "Ca",\
	        "Sc", "Ti", "V" , "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn",\
			"Ga", "Ge", "As", "Se", "Br", "Kr", "Rb", "Sr", "Y" , "Zr",\
			"Nb", "Mo", "Tc", "Ru", "Rh", "Pd", "Ag", "Cd", "In", "Sn",\
			"Sb", "Te", "I" , "Xe", "Cs", "Ba", "La", "Ce", "Pr", "Nd",\
			"Pm", "Sm", "Eu", "Gd", "Tb", "Dy", "Ho", "Er", "Tm", "Yb",\
			"Lu", "Hf", "Ta", "W" , "Re", "Os", "Ir", "Pt", "Au", "Hg",\
			"Tl", "Pb", "Bi", "Po", "At", "Rn", "Fr", "Ra", "Ac", "Th",\
			"Pa", "U" , "Np", "Pu", "Am", "Cm", "Bk", "Cf", "Es", "Fm",\
			"Md", "No", "Lr", "Rf", "Db", "Sg", "Bh", "Hs", "Mt", "Ds",\
    };

#define __angstrom2bohr__ 1.8897259886
#define __hartree2ev__ 27.21139664130791
